## sdpb 1.0

=== Makefile ===
UNAME := $(shell uname)

################ Modify these variables ################

ifeq ($(UNAME), Darwin)
# Mac OS X Defaults, assuming Readme instructions.

GMPINCLUDEDIR   = /usr/local/include
BOOSTINCLUDEDIR = /usr/local/include/boost
LIBDIR          = /usr/local/lib

else
# If you're using Linux or Windows or a nonstandard OS X setup, modify
# these variables to point to the appropriate places.

BASEDIR := $(HOME)

# directory containing the header files 'gmp.h' and 'gmpxx.h'
GMPINCLUDEDIR   = $(BASEDIR)/include

# directory containing boost header files, e.g. 'bind.hpp', etc.
BOOSTINCLUDEDIR = $(BASEDIR)/include/boost

# directory containing library files, e.g.
#   libboost_filesystem.a,
#   libboost_filesystem.so,
#   libboost_filesystem.so.1.54.0
# as well as analogous files for 'boost_system',
# 'boost_serialization', 'boost_timer', 'boost_program_options',
# 'gmp', and 'gmpxx',
LIBDIR          = $(BASEDIR)/lib

endif

################ End of modifications ################

SOURCES = $(wildcard src/*.cpp) $(wildcard src/mpack/*.cpp)
HEADERS = $(wildcard src/*.h) $(wildcard src/mpack/*.h)
OBJECTS = $(patsubst src/%.cpp,obj/%.o,$(SOURCES))
RESULT  = sdpb

ifeq ($(SHARED_TINYXML2), 1)
LIBS = -ltinyxml2
else
SOURCES += $(wildcard src/tinyxml2/*.cpp)
HEADERS += $(wildcard src/tinyxml2/*.h)
endif

ifdef INTEL

CC = icpc
CFLAGS += -g -O2 -ipo -xhost -Wall -ansi -std=c++0x -L${LIBDIR} -Isrc/mpack -I${GMPINCLUDEDIR} -I${BOOSTINCLUDEDIR} -openmp -D___MPACK_BUILD_WITH_GMP___
LIBS += -lgmpxx -lgmp -lboost_serialization -lboost_system -lboost_filesystem -lboost_timer -lboost_program_options -lboost_chrono -lrt

else 
ifdef CLANG

CC = clang-omp
CFLAGS += -g -O2 -Wall -ansi -std=c++0x -L${LIBDIR} -Isrc/mpack -I${GMPINCLUDEDIR} -I${BOOSTINCLUDEDIR} -fopenmp -D___MPACK_BUILD_WITH_GMP___
LIBS +=  -liomp5 -lgmpxx -lgmp -lboost_serialization -lboost_system -lboost_filesystem -lboost_timer -lboost_program_options -lboost_chrono -lc++

else

CC = g++
CFLAGS += -g -O2 -Wall -ansi -std=c++0x -L${LIBDIR} -Isrc/mpack -I${GMPINCLUDEDIR} -I${BOOSTINCLUDEDIR} -fopenmp -D___MPACK_BUILD_WITH_GMP___
LIBS += -lgomp -lgmpxx -lgmp -lboost_serialization -lboost_system -lboost_filesystem -lboost_timer -lboost_program_options -lboost_chrono -lrt

endif
endif


.SUFFIXES: .cpp .o

$(RESULT): $(OBJECTS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)

obj/%.o: src/%.cpp
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	rm -rf obj

obj:
	@mkdir -p $@
	@mkdir -p $@/mpack
	@mkdir -p $@/tinyxml2

test:
	./sdpb -s test.xml --noFinalCheckpoint
	test -f test.out
	grep "primalObjective = 1.84026576313204924668804017173" test.out > /dev/null || \
	(echo "Test failed: primalObjective differs from 1.84026576313204924668804017173." && exit 1)

$(OBJECTS): $(HEADERS) | obj

CFLAGS += -MMD
-include $(OBJECTS:.o=.d)

=== debian/changelog ===
sdpb (1.0-4) unstable; urgency=medium

  * Team Upload.
  * Use proper variable name for compiler to fix non-crossbuildability
  * Switch to maintainer manual pages
  * Drop help2man from Build-Deps, do not run it during build time
  * Switch VCS URLs to salsa
  * Use secure https URL
  * Clean manpage mess

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 20 Feb 2021 16:52:13 +0530

sdpb (1.0-3) unstable; urgency=medium

  * Build-Depend on boost dev packages from boost-defaults.

 -- Tobias Hansen <thansen@debian.org>  Sun, 19 Mar 2017 14:49:55 +0000

sdpb (1.0-2) unstable; urgency=medium

  * Add patch use-system-tinyxml2.h.patch. (Closes: #857310)
  * Use boost 1.63 instead of 1.62.

 -- Tobias Hansen <thansen@debian.org>  Sun, 19 Mar 2017 00:06:27 +0000

sdpb (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #856704)

 -- Tobias Hansen <thansen@debian.org>  Wed, 08 Mar 2017 23:09:00 -0500

=== debian/control ===
Source: sdpb
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>
Section: math
Priority: optional
Standards-Version: 3.9.8
Homepage: https://github.com/davidsd/sdpb
Vcs-Browser: https://salsa.debian.org/science-team/sdpb
Vcs-Git: https://salsa.debian.org/science-team/sdpb.git
Build-Depends: debhelper (>= 10),
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-timer-dev,
               libgmp-dev,
               libtinyxml2-dev
Build-Depends-Indep: texlive-fonts-recommended,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-pictures

Package: sdpb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sdpb-doc
Description: Semidefinite program solver
 SDPB is an open-source, arbitrary-precision, parallelized semidefinite
 program solver, designed for the conformal bootstrap. SDPB significantly
 outperforms less specialized solvers and should enable many new computations.
 .
 For more information, see "A Semidefinite Program Solver for the Conformal
 Bootstrap" at http://arxiv.org/abs/1502.02033.

Package: sdpb-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Semidefinite program solver (documentation)
 SDPB is an open-source, arbitrary-precision, parallelized semidefinite
 program solver, designed for the conformal bootstrap. SDPB significantly
 outperforms less specialized solvers and should enable many new computations.
 .
 For more information, see "A Semidefinite Program Solver for the Conformal
 Bootstrap" at http://arxiv.org/abs/1502.02033.
 .
 This package contains the manual and example files, including a Mathematica
 file with code to export semidefinite programs in the XML-based format used
 by SDPB.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sdpb-$1\.tar\.gz/ \
  https://github.com/davidsd/sdpb/tags .*/v?(\d\S+)\.tar\.gz
